//---------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "ResolutionForm.h"
#include <d3dx8.h>
//--------------------------------------------------------------------- 
#pragma resource "*.dfm"
TResForm *ResForm;
//---------------------------------------------------------------------
__fastcall TResForm::TResForm(TComponent* AOwner)
	: TForm(AOwner)
{
    wind_dir = D3DXVECTOR3(0,0,1);
    FirstInit = TRUE;
}
//---------------------------------------------------------------------
void __fastcall TResForm::OKBtnClick(TObject *Sender)
{
    FirstInit = FALSE;
    ModalResult = ComboBox1->ItemIndex+1;
}
//---------------------------------------------------------------------------
void __fastcall TResForm::FormCreate(TObject *Sender)
{
    ComboBox1->ItemIndex=0;
}
//---------------------------------------------------------------------------
void __fastcall TResForm::DrawWidthTrackBarChange(TObject *Sender)
{
    WidthText->Caption = AnsiString(DrawWidthTrackBar->Position);
}
//---------------------------------------------------------------------------
void __fastcall TResForm::DrawHeightTrackBarChange(TObject *Sender)
{
    HeightText->Caption = AnsiString(DrawHeightTrackBar->Position);
}
//---------------------------------------------------------------------------
void __fastcall TResForm::RainDensityTrackBarChange(TObject *Sender)
{
    long t = RainDensityTrackBar->Position;
    AnsiString text;
    if(t<10)
        text = AnsiString("Morning Dew");
    if(t>=10 && t<20)
        text = AnsiString("A Light Mist");
    if(t>=20 && t<30)
        text = AnsiString("Summer Shower");
    if(t>=30 && t<40)
        text = AnsiString("Storm");
    if(t>=40 && t<50)
        text = AnsiString("Squall");
    if(t>=50 && t<60)
        text = AnsiString("Down-Pour");
    if(t>=60 && t<70)
        text = AnsiString("Tempest");
    if(t>=70 && t<80)
        text = AnsiString("Tropical Depression");
    if(t>=80 && t<90)
        text = AnsiString("Hurricane");
    if(t>=90)
        text = AnsiString("Noah's Flood");

    DensityText->Caption = text + AnsiString(" (") + AnsiString(t) + AnsiString(')');
}
//---------------------------------------------------------------------------
void __fastcall TResForm::RainHeightTrackBarChange(TObject *Sender)
{
    RainHeightText->Caption = AnsiString(RainHeightTrackBar->Position);
}
//---------------------------------------------------------------------------
void __fastcall TResForm::WindSpeedTrackBarChange(TObject *Sender)
{
    float t = ((float)WindSpeedTrackBar->Position/100);
    AnsiString text;
    if(t==0.00)
        text = AnsiString("No Wind :-(");
    if(t>0.00 && t<0.20)
        text = AnsiString("Calm Air");
    if(t>=0.20 && t<0.40)
        text = AnsiString("Light Wind");
    if(t>=0.40 && t<0.60)
        text = AnsiString("Slight Breeze");
    if(t>=0.60 && t<0.80)
        text = AnsiString("Breeze");
    if(t>=0.80 && t<1.00)
        text = AnsiString("Blowing");
    if(t>=1.00 && t<1.20)
        text = AnsiString("Windy");
    if(t>=1.20 && t<1.40)
        text = AnsiString("Stormy");
    if(t>=1.40 && t<1.60)
        text = AnsiString("Tornado");
    if(t>=1.60 && t<1.80)
        text = AnsiString("Gale Force");
    if(t>=1.80)
        text = AnsiString("The Breath Of God");

    WindSpeedText->Caption = text + AnsiString(" (") + FormatFloat(AnsiString("0.00"),t) + AnsiString(')');
}
//---------------------------------------------------------------------------
void __fastcall TResForm::WindDirectionTrackBarChange(TObject *Sender)
{
    DirectionText->Caption = AnsiString(WindDirectionTrackBar->Position)+AnsiString('');
    Circle->Canvas->Ellipse(0,0,41,41);
    Circle->Canvas->MoveTo(20,20);

    float degree = D3DXToRadian(WindDirectionTrackBar->Position);
    Circle->Canvas->LineTo(20+sin((D3DX_PI)-degree)*19,20+cos((D3DX_PI)-degree)*19);

    wind_dir = D3DXVECTOR3(sin(degree),0,
                            cos(degree));
}
//---------------------------------------------------------------------------
void __fastcall TResForm::FormActivate(TObject *Sender)
{
    Circle->Canvas->Ellipse(0,0,41,41);
    Circle->Canvas->MoveTo(20,20);
    Circle->Canvas->LineTo(20,1);

    if(!FirstInit)
    {
        FullScreenCheckBox->Enabled = FALSE;
        ComboBox1->Enabled = FALSE;
        DaytimeCheckbox->Enabled = FALSE;
    }
}
//---------------------------------------------------------------------------
void __fastcall TResForm::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if(Key==VK_SPACE)
        OKBtn->Click();
}
//---------------------------------------------------------------------------

