//---------------------------------------------------------------------------
#ifndef SoundH
#define SoundH

#include <windows.h>
#include <windowsx.h>
#include <mmsystem.h>
#include <dsound.h>

#define NVB_SIZE 6 //voc file stuff

#define MAX_SOUNDS  64
#define MAX_COPIES  10

typedef struct _SoundStruct
{
    _SoundStruct()
    {
        Loaded = FALSE;
        PlaybackRate = 22222;
        Size = 0;
        Buffer = NULL;
        bCopies = FALSE;
        for(int i=0;i<MAX_COPIES;i++)
        {
            Copies[i] = NULL;
        }
    }

    BOOL Loaded;
    UINT PlaybackRate;
    UINT Size;
    LPDIRECTSOUNDBUFFER Buffer;

    BOOL bCopies;
    LPDIRECTSOUNDBUFFER Copies[MAX_COPIES];

}SoundStruct;

typedef struct _SSFHeader
{
    _SSFHeader()
    {
        TotalSamples = 0;
        BitsPerSample = 16;
        SampleRate = 44100;
        DataBytes = 0;
        Seconds = 0.00;
    }
    unsigned long TotalSamples;
    unsigned char BitsPerSample;
    unsigned long SampleRate;
    unsigned long DataBytes;
    float Seconds;
}SSFHeader;

void InitializeDirectSound(HWND window);
void DestroyDirectSound(void);

long LoadSoundVOC(char *filename); //loads a .voc file and returns an index to it
long LoadSoundSSF(char *filename); //loads a .ssf file and returns an index to it

void PlaySound(long index,BOOL loop,float volume=-999.999);
void StopSound(long index);
void SetSoundVolume(long index,float volume);  //between 0 and 1; 0 is full volume, 1 is no volume 
void MakeCopiesOfSound(long index);   //sets up the sounds copies

void StopAllSounds(void);
void ReleaseAllSounds(void);

//---------------------------------------------------------------------------
#endif
