#include <condefs.h>
#include <string>
#include <conio.h>
#include <fstream.h>

//---------------------------------------------------------------------------
#pragma argsused

typedef struct _h
{
    _h()
    {
        TotalSamples = 0;
        BitsPerSample = 16;
        SampleRate = 44100;
        DataBytes = 0;
        Seconds = 0.00;
    }
    unsigned long TotalSamples;
    unsigned char BitsPerSample;
    unsigned long SampleRate;
    unsigned long DataBytes;
    float Seconds;
}h;

void main(int argc, char* argv[])
{
    if(argc<2)
    {
        cerr << "No file input!";
        getch();
        return;
    }
    ifstream i;
    ofstream o;
    unsigned short temp_buf_16=0; //for writing
    unsigned char temp_buf_8=0;   //for writing
    i.open(argv[1],ios::in);
    if(i.is_open()==false)
        return;
    cout << "\nReading: ";
    cout << argv[1];

    long slength = strlen(argv[1]);
    argv[1][slength-3] = 's';
    argv[1][slength-2] = 's';
    argv[1][slength-1] = 'f';
    o.open(argv[1],ios::out | ios::binary | ios::trunc);
    if(o.is_open()==false)
    {
        i.close();
        return;
    }
    cout << "\nWriting: ";
    cout << argv[1];

    ///////////////////
    //read the header//
    ///////////////////
    h header = h();
    int Channels=0;
    char dummy[256];
    i >> dummy;
    i >> header.TotalSamples;
    cout << "\n\nTotal Samples: " << header.TotalSamples;
    i >> dummy;
    int temp;
    i >> temp;
    header.BitsPerSample=(unsigned char)temp;
    cout << "\nBits Per Sample: " << (int)header.BitsPerSample;
    i >> dummy;
    i >> Channels;
    cout << "\nChannels: " << Channels;
    if(Channels>1)
    {
        cerr << "\n\nOnly supports Mono files. Sorry!";
        goto end;
    }
    i >> dummy;
    i >> header.SampleRate;
    cout << "\nSample Rate: " << header.SampleRate;
    i >> dummy;
    i >> dummy;
    header.DataBytes = header.TotalSamples*(header.BitsPerSample/8);
    header.Seconds = header.TotalSamples/header.SampleRate;
    cout << "\nTotal Data (in bytes): " << header.DataBytes;
    cout << "\nSound Length (in sec.): " << header.Seconds;

    cout << "\n\nWriting Header...";
    o.write((char *)&header,sizeof(header));
    cout << "Done.";

    char temp_in[80];
    cout << "\n\nWriting Data";
    i.ignore();
    for(unsigned long index=0;index<header.TotalSamples;index++)
    {
        if(header.BitsPerSample==16)
        {
            i.getline(temp_in,80,'\n');
            temp_buf_16 = (unsigned short)atol(temp_in);
            o.write((char*)&temp_buf_16,sizeof(unsigned short));
            if(index%header.SampleRate ==0)
                cout << ".";
        }
        else
        {
            i.getline(temp_in,80,'\n');
            temp_buf_8 = (unsigned char)atol(temp_in);
            o.write((char*)&temp_buf_8,sizeof(unsigned char));
            if(index%header.SampleRate ==0)
                cout << ".";
        }
    }
    cout << "Done.\n\nPress a key to exit.";

    end:
    i.close();
    o.close();

    getch();
}
