//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <d3dx8.h>
#include "Vertex.h"
#include "Terra.h"
#include "Ignis.h"
#include "Aqua.h"
#include "Zephyr.h"
#include "Sound.h"

Zephyr::Zephyr()
{
    Earth = NULL;
    Fire = NULL;
    Water = NULL;

    WindSound = NULL;

    WindDirection = D3DXVECTOR3(0,0,1);
    Speed = 0.5;
}

Zephyr::~Zephyr()
{
}

int Zephyr::Initialize(Terra *t,Ignis *i,Aqua *a)
{
    Earth = t;
    Fire = i;
    Water = a;

    WindSound = LoadSoundSSF("Sounds\\Wind.ssf");
    SetSoundVolume(WindSound,(2-Speed)*(0.1));
    PlaySound(WindSound,TRUE);
    return 1;
}

void Zephyr::Update(float MoveSpeed)
{
    D3DXVECTOR3 mul_vec = WindDirection*MoveSpeed*Speed;

    SetSoundVolume(WindSound,(2-Speed)*(0.1));

    //apply wind to the earth//
    for(long y=0;y<Earth->DrawHeight;y++)
    {
      for(long x=0;x<Earth->DrawWidth;x++)
      {
        if(D3DXVec3Length(&Earth->Grid[(y*GRID_HEIGHT)+x].Velocity)>0.01)
        {
            Earth->Grid[(y*GRID_HEIGHT)+x].Velocity += mul_vec;
        }
      }
    }

    //apply wind to the fire//
    for(long i=0;i<MAX_PARTICLES;i++)
    {
        if(Fire->Particles[i].Active)
        {
            Fire->Particles[i].Vel += mul_vec;
        }
    }

    //apply wind to the water//
    for(long i=0;i<MAX_RAIN;i++)
    {
        if(Water->Rain[i].Active)
        {
            Water->Rain[i].Vel += mul_vec;
        }
    }
}

//---------------------------------------------------------------------------
